.data

PI real8 3.14
DAYS_OF_MONTH dword 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31

.code

;---------------------------------------- chapter2

add_int proc
	mov eax, ecx
	add eax, edx
	ret
add_int endp

add_int2 proc
	add ecx, edx
	mov eax, ecx
	ret
add_int2 endp

add_int64 proc
	mov rax, rcx
	add rax, rdx
	ret
add_int64 endp

sub_int proc
	mov eax, ecx
	sub eax, edx
	ret
sub_int endp

mul_int proc
	mov eax, ecx
	imul eax, edx
	ret
mul_int endp

mul_int2 proc
	mov eax, ecx
	imul edx
	ret
mul_int2 endp

div_int proc
	mov eax, ecx
	mov ecx, edx
	cdq
	idiv ecx
	ret
div_int endp

mod_int proc
	mov eax, ecx
	mov ecx, edx
	cdq
	idiv ecx
	mov eax, edx
	ret
mod_int endp

add_double proc
	addsd xmm0, xmm1
	ret
add_double endp

sub_double proc
	subsd xmm0, xmm1
	ret
sub_double endp

mul_double proc
	mulsd xmm0, xmm1
	ret
mul_double endp

div_double proc
	divsd xmm0, xmm1
	ret
div_double endp

;---------------------------------------- chapter3

area_circle proc
	mulsd xmm0, xmm0
	mulsd xmm0, PI
	ret
area_circle endp

days_of_january proc
	lea rdx, DAYS_OF_MONTH
	mov eax, [rdx]
	ret
days_of_january endp

days_of_february proc
	lea rdx, DAYS_OF_MONTH
	mov eax, [rdx+4]
	ret
days_of_february endp

days_of_month proc
	lea rdx, DAYS_OF_MONTH
	mov eax, [rdx+rcx*4-4]
	ret
days_of_month endp

add_int_lea proc
	lea eax, [ecx+edx]
	ret
add_int_lea endp

sum_array proc
	mov eax, [rcx]
	add eax, [rcx+4]
	add eax, [rcx+8]
	ret
sum_array endp

sum_array2 proc
	mov eax, [rcx]
	add eax, [rcx+4]
	add eax, [rcx+8]
	add eax, [rcx+12]
	add eax, [rcx+16]
	ret
sum_array2 endp

;---------------------------------------- chapter4

min proc
	mov eax, ecx
	cmp eax, edx
	jle min_end
	mov eax, edx
min_end:
	ret
min endp

max proc
	mov eax, ecx
	cmp eax, edx
	jge max_end
	mov eax, edx
max_end:
	ret
max endp

min2 proc
	mov eax, ecx
	cmp eax, edx
	jle min2_next
	mov eax, edx
min2_next:
	cmp eax, r8d
	jle min2_end
	mov eax, r8d
min2_end:
	ret
min2 endp

max2 proc
	mov eax, ecx
	cmp eax, edx
	jge max2_next
	mov eax, edx
max2_next:
	cmp eax, r8d
	jge max2_end
	mov eax, r8d
max2_end:
	ret
max2 endp

power proc
	mov eax, 1
	jmp power_start
power_repeat:
	imul eax, ecx
power_start:
	dec edx
	jge power_repeat
	ret
power endp

sum_loop proc
	mov eax, 0
	jmp sum_loop_start
sum_loop_repeat:
	add eax, [rcx]
	add rcx, 4
sum_loop_start:
	dec edx
	jge sum_loop_repeat
	ret
sum_loop endp

;---------------------------------------- chapter5

min_call proc
	call min2
	mov ecx, eax
	mov edx, r9d
	call min
	ret
min_call endp

min_call2 proc
	call min2
	mov ecx, eax
	mov edx, r9d
	mov r8d, [rsp+40]
	call min2
	ret
min_call2 endp

average proc
	mov r8d, edx
	call sum_loop
	cdq
	idiv r8d
	ret
average endp

average2 proc
	push rbx
	mov ebx, edx
	call sum_loop
	cdq
	idiv ebx
	pop rbx
	ret
average2 endp

average3 proc
	mov [rsp+16], edx
	call sum_loop
	cdq
	idiv dword ptr [rsp+16]
	ret
average3 endp

gcd proc
	mov eax, ecx
	test edx, edx
	jz gcd_end
	mov ecx, edx
	cdq
	idiv ecx
	call gcd
gcd_end:
	ret
gcd endp

gcd2 proc
	mov eax, ecx
	test edx, edx
	jz gcd2_end
	mov ecx, edx
	cdq
	idiv ecx
	jmp gcd2
gcd2_end:
	ret
gcd2 endp

end
